CREATE OR REPLACE PROCEDURE DUPLICA_SOLICITACAO
(P_CDFILIAL   IN SOLISERV.CDFILIAL%TYPE,
 P_NRSOLISERV IN SOLISERV.NRSOLISERV%TYPE,
 P_IDSOLIGR   IN SOLISERV.IDSTATUSSOLI%TYPE DEFAULT 'N')

AS

   V_NRSOLISERV    NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_DSREFETAREFA  SOLISERV.DSREFESOLI%TYPE;
   V_NRPLATIVTARE  NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_CDPRODATUAL   SOLISERV.CDPRODGRUP%TYPE;
   V_CDPRODSOLI    SOLISERV.CDPRODGRUP%TYPE;
   V_CDPRODAUXI    SOLISERV.CDPRODGRUP%TYPE;
   V_CDARVCOMP     PRODUTO.CDARVPROD%TYPE;
   V_CDARVGRUP     PRODUTO.CDARVPROD%TYPE;
   V_CDARVPROD     PRODUTO.CDARVPROD%TYPE;
   V_CDPRODCOMP    PRODUTO.CDPRODUTO%TYPE;
   V_CDASSUATUAL   SOLISERV.CDASSUNTO%TYPE;
   V_CDASSUNTO     SOLISERV.CDASSUNTO%TYPE;
   V_CDCLIENTE     SOLISERV.CDCLIENTE%TYPE;
   V_DSSOLISERV    DESCSOLI.DSSOLISERV%TYPE;
   V_CDFASETRAM    SOLISERV.CDFASETRAM%TYPE;

BEGIN
   BEGIN
      SELECT CDPRODGRUP, CDASSUNTO, CDCLIENTE,
             (SELECT SUBSTR(CDARVPROD,5,3) FROM PRODUTO WHERE CDPRODUTO = S.CDPRODCOMP) AS CDARVCOMP
      INTO V_CDPRODSOLI, V_CDASSUNTO, V_CDCLIENTE,
           V_CDARVCOMP
      FROM SOLISERV S
      WHERE CDFILIAL = P_CDFILIAL
        AND NRSOLISERV = P_NRSOLISERV;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         NULL;
   END;

   IF (V_CDCLIENTE = 'J02905110000128') OR            /*GR - Regional SP*/
      (V_CDCLIENTE = 'J76900463000171') OR            /*Risotolandia*/
      (V_CDCLIENTE = 'J66154790000178') OR            /*ServCater*/
      (V_CDCLIENTE = 'J33375601000138') OR            /*Caterair*/
      (V_CDCLIENTE = 'J02320714000102') OR            /*Bahia Catering*/
      (V_CDCLIENTE = 'I00000000003051625317') OR      /*Sky Argentina*/
      (V_CDCLIENTE = 'I00000000000813484005') THEN    /*Sky Chile*/

      NOVO_CODIGO('SOLISERV'||P_CDFILIAL, V_NRSOLISERV);
      V_NRSOLISERV := SUBSTR(V_NRSOLISERV,11,10);

      IF P_IDSOLIGR = 'N' THEN
         SELECT MAX(CDPRODUTO)
         INTO V_CDPRODATUAL
         FROM PRODUTO
         WHERE CDARVPROD LIKE 'P%'
           AND CDNVPRODUTO = '3'
           AND DSDIRBASEVER IS NOT NULL;
      ELSE
         SELECT MAX(CDPRODUTO)
         INTO V_CDPRODAUXI
         FROM PRODUTO
         WHERE CDARVPROD LIKE 'P%'
           AND CDNVPRODUTO = '3'
           AND DSDIRBASEVER IS NOT NULL;

         IF (V_CDPRODAUXI <> V_CDPRODSOLI) THEN
            SELECT MAX(CDPRODUTO)
            INTO V_CDPRODATUAL
            FROM PRODUTO
            WHERE CDARVPROD LIKE 'P%'
              AND CDNVPRODUTO = '3'
              AND DSDIRBASEVER IS NOT NULL
              AND CDPRODUTO <> V_CDPRODAUXI;
         ELSE
            V_CDPRODATUAL := V_CDPRODAUXI;
         END IF;
      END IF;

      BEGIN
         SELECT CDARVPROD
         INTO V_CDARVGRUP
         FROM PRODUTO
         WHERE CDPRODUTO = V_CDPRODATUAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            NULL;
      END;

      BEGIN
         SELECT CDPRODUTO
         INTO V_CDPRODCOMP
         FROM PRODUTO
         WHERE CDARVPROD = V_CDARVGRUP||V_CDARVCOMP;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            NULL;
      END;

      V_CDARVPROD := SUBSTR(V_CDARVGRUP,2,3);

      IF (V_CDPRODATUAL <> V_CDPRODSOLI) THEN
         IF (V_CDASSUNTO = '00010') OR       /*Erro Leve*/
            (V_CDASSUNTO = '00011') OR       /*Erro Grave*/
            (V_CDASSUNTO = '00102') THEN     /*Erro em Sistema*/

            V_CDASSUATUAL := '00015';        /*Correo de Erro em Outras Verses*/

         ELSIF (V_CDASSUNTO = '00013') OR    /*Evoluo tecnolgica - manuteno*/
               (V_CDASSUNTO = '00124') OR    /*Evoluo tecnolgica*/
               (V_CDASSUNTO = '00021') THEN  /*Customizao - especfico do cliente*/

            V_CDASSUATUAL := '00014';        /*Evoluo tecnolgica - Teknisa*/

         END IF;

         SELECT CDFASETRAM
         INTO V_CDFASETRAM
         FROM PARAMGERAL;

         INSERT INTO SOLISERV
         (CDFILIAL, NRSOLISERV, NRPRIOSOLI, DSREFESOLI,
          CDASSUNTO, CDOPERADOR, CDPRODCOMP, CDPRODGRUP,
          CDVERPROORIG, CDCLIENTE, CDFASETRAM, DTABERSOLI,
          IDSTATUSSOLI, IDSOLIENCE, NRLICENCAUSO, IDRESDISPVER,
          CDOPERSOLI, CDOPERRESP, IDSOLILIDA, NRSOLIORIG)
         (SELECT CDFILIAL, V_NRSOLISERV, NRPRIOSOLI, SUBSTR('(' ||TO_CHAR(TO_NUMBER(NRSOLISERV)) || ' - ' || V_CDARVPROD || ') '||DSREFESOLI,1,60),
                 V_CDASSUATUAL, CDOPERADOR, NVL(V_CDPRODCOMP, CDPRODCOMP), V_CDPRODATUAL,
                 CDVERPROORIG, CDCLIENTE, V_CDFASETRAM, SYSDATE,
                 'P', 'N', NRLICENCAUSO, IDRESDISPVER, '000000000991',
                 RESPONSAVEL_POR_SISTEMA(CDPRODCOMP), IDSOLILIDA, NRSOLISERV
          FROM SOLISERV
          WHERE CDFILIAL = P_CDFILIAL
            AND NRSOLISERV = P_NRSOLISERV);

         INSERT INTO LOGFASETRAM
         (CDFILIAL, NRSOLISERV, DTALFASETRAM, CDFASETRAM,
          CDOPERADOR, DSALFASETRAM, CDOPERRESP, TXACAOLFTRAM)
         (SELECT L.CDFILIAL, V_NRSOLISERV, SYSDATE, L.CDFASETRAM,
                 '000000000991', 'Referencia ' ||TO_CHAR(TO_NUMBER(L.NRSOLISERV)) || ' - Verso ' || V_CDARVPROD,
                 RESPONSAVEL_POR_SISTEMA(S.CDPRODCOMP), L.TXACAOLFTRAM
          FROM LOGFASETRAM L, SOLISERV S
          WHERE L.CDFILIAL = P_CDFILIAL
            AND L.NRSOLISERV = P_NRSOLISERV
            AND S.CDFILIAL = P_CDFILIAL
            AND S.NRSOLISERV = P_NRSOLISERV
            AND DTALFASETRAM = (SELECT MIN(DTALFASETRAM)
                                FROM LOGFASETRAM
                                WHERE CDFILIAL = P_CDFILIAL
                                  AND NRSOLISERV = P_NRSOLISERV));

         SELECT DSSOLISERV
         INTO V_DSSOLISERV
         FROM DESCSOLI
         WHERE CDFILIAL = P_CDFILIAL
           AND NRSOLISERV = P_NRSOLISERV;

         INSERT INTO DESCSOLI
         (CDFILIAL, NRSOLISERV, DSSOLISERV)
         VALUES
         (P_CDFILIAL, V_NRSOLISERV, V_DSSOLISERV);
      END IF;
   END IF;

   IF P_IDSOLIGR = 'S' THEN
      DUPLICA_SOLICITACAO(P_CDFILIAL, P_NRSOLISERV, 'N');
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('DUPLICA_SOLICITACAO','4.11.046'); END;
/

